
import java.io.File;
import java.util.Locale;
import java.util.ResourceBundle;

import sdljava.SDLException;
import sdljava.video.SDLSurface;

public class Options {

	private static boolean online;
	private boolean end ; //determina cuando salir del programa
	private boolean fullscreen ;

	private Text textArabica8;
	private Text textCalculator40;
	
	private CFrame frameBackgroundOptions;
	private CSprite spriteBackgroundOptions;
	
	private Event event;
	
	private CFrame framebordercircleoff;
	private CFrame framebordercircleon;
	private CFrame frameborderoff;
	private CFrame frameborderon;
	private CFrame framebuttoncircle;
	private CFrame framebuttonoff;
	private CFrame framebuttonon;
	
	private CSprite spritebordercircle;
	private CSprite spriteborder;
	private CSprite spritebutton;
	private CSprite spritebuttoncircle;
	
	private Keyboard keyboard;

	private  int maxoption;

	private int numoption;

	static  int staffmode;
    
	
	public static boolean auto = false;

	public static  Locale local ;
	
	public boolean getFullscreen(){
		return this.fullscreen;
	}
	public Options(){
		
		this.initsprites();
		this.init();
	}
    public void initsprites() {
		
    	//init sprites

		framebordercircleoff= new CFrame();
		framebordercircleon= new CFrame();
		frameborderoff= new CFrame();
		frameborderon= new CFrame();
		framebuttoncircle= new CFrame();
		framebuttonoff= new CFrame();
		framebuttonon= new CFrame();
			
		spritebordercircle = new CSprite();
		spriteborder = new CSprite();
		spritebutton = new CSprite();
		spritebuttoncircle = new CSprite();

		frameBackgroundOptions = new CFrame();
		spriteBackgroundOptions = new CSprite();
		
		try {
			framebordercircleoff.load("sprites"+  File.separator + "bordercircleoff.png");
			framebordercircleon.load("sprites"+  File.separator + "bordercircleon.png");
			frameborderoff.load("sprites"+  File.separator + "borderoff.png");
			frameborderon.load("sprites"+  File.separator + "borderon.png");
			framebuttonoff.load("sprites"+  File.separator + "buttonoff.png");
			framebuttonon.load("sprites"+  File.separator + "buttonon.png");
			framebuttoncircle.load("sprites"+  File.separator + "buttoncircle.png");
	    			
	    	spritebordercircle.addframe(framebordercircleoff);
	    	spritebordercircle.addframe(framebordercircleon);
	    	spriteborder.addframe(frameborderoff);
	    	spriteborder.addframe(frameborderon);
	    	spritebutton.addframe(framebuttonoff);
	    	spritebutton.addframe(framebuttonon);
	    	spritebuttoncircle.addframe(framebuttoncircle);
	  
	    	frameBackgroundOptions.load("sprites"+  File.separator + "pianooptions.png");
			spriteBackgroundOptions.addframe(frameBackgroundOptions);
		}
		catch(Exception e){
			System.out.println("Error Options.initsprites "+e );
		}
    }
	@SuppressWarnings("static-access")
	void draw(SDLSurface screen){
		//System.out.println("draw");
		
		try {
			spriteBackgroundOptions.draw(screen);
	
			spritebutton.setx(160);
			spriteborder.setx(160);
			
			spritebutton.setframe(staffmode);
			spritebutton.sety(205);
			spritebutton.draw(screen);
			
			if (numoption==0){
				spriteborder.setframe(1);
			}
			else{
				spriteborder.setframe(0);
			}
			spriteborder.sety(205);
			spriteborder.draw(screen);
			textArabica8.drawtext(ResourceBundle.getBundle("Language",this.local.getDefault()).getString("Partitura"), screen, 170, 210);
			
			if (fullscreen){
				
				spritebutton.setframe(1);
			}
			else{
				spritebutton.setframe(0);
			}
			
			spritebutton.sety(260); // + 55
			spritebutton.draw(screen);
			
			if (numoption==1){
				spriteborder.setframe(1);
			}
			else{
				spriteborder.setframe(0);
			}
			spriteborder.sety(260);
			spriteborder.draw(screen);
			textArabica8.drawtext(ResourceBundle.getBundle("Language",this.local.getDefault()).getString("Ventana"), screen, 170, 265);
		
		//language
			textArabica8.drawtext(ResourceBundle.getBundle("Language",this.local.getDefault()).getString("IDIOMA"), screen, 160, 305);
			//text.drawtext("-", screen, 210, 370);
			
			if (numoption ==2){
				spritebordercircle.setframe(1);
			}
			else{
				spritebordercircle.setframe(0);
			}
			spritebordercircle.setx(160);
			spritebordercircle.sety(310);
			spritebordercircle.draw(screen);
		
			spritebuttoncircle.setx(160);
			spritebuttoncircle.sety(310);
			spritebuttoncircle.draw(screen);
	
			textCalculator40.drawtext(String.valueOf(this.local.getDefault().getLanguage()), screen, 335, 310);
	
	    	screen.flip(); //Pintamos la pantalla
	    	   
		  	//screen.fillRect(0); //borramos la pantalla anterior	
		} catch (SDLException e) {
			System.out.println("Error options.draw"+e);
		}
		
	}
	public void init() { //inicializa
	
		event = new Event();
		 		   
		staffmode = 0;
		this.maxoption = 3;
	    keyboard = new Keyboard();
	    
	    textCalculator40 = new Text();
	    textCalculator40.init("fonts"+  File.separator + "calculator.ttf",40);
	    textCalculator40.setcolor(47, 131, 43);

	    textArabica8 = new Text();
	    textArabica8.init("fonts"+  File.separator + "arabica.ttf",8);

	    textArabica8.setcolor(87, 88,90);
	    
	}

	public void keyboard(SDLSurface screen) {
		
		int sym = 0;
		event.setEvent();
		try{
			if (event.isPressed()){
					
				sym = event.getSym();
	
				switch (sym){
	    	
			    	case 27 : 
			    		
			 	    	this.end = true;
			 	    	keyboard.waitrelease();
			    		break;
		    	
			    	case 276://izquierda
			    		break;
			    	case 275:
			    		break;
			    	case 273:
			    		if (this.numoption > 0 ){
			    			this.numoption--;
			    		}
			    		break;
			    	case 274:
			    		if (this.numoption+1 < this.maxoption){
			    			this.numoption++;
			    		}
			    		break;
			    	case 13: //enter
			    		
			    		if (numoption==0){ //modo partitura/vertical
			    			
			    			if (staffmode==0) staffmode=1;
			    			else staffmode=0;
			    		}
			    		if (numoption==1){ //pantalla completa
		  			
			    			fullscreen=!fullscreen;
			    			screen.wmToggleFullScreen();
			    		}

			    		if (numoption==2){ //opcion 3
			    			
			    			this.changelocale();
			    		}
		
			    		break;
				}//fin switch
				this.draw(screen);
			}//fin if (event.isPressed())
		}//fin try
		catch(Exception e){
			System.out.println("Error options.keyboard "+e);
		}
	}

	int go(SDLSurface screen){
		
		this.draw(screen);
		
		this.end = false;
		while(!this.end){
				
			try {
				this.keyboard(screen);
				Thread.sleep(100);
			} catch (InterruptedException e) {

				e.printStackTrace();
			}
		}

		return 0 ;
	}
	public static void setOnline(boolean online) {
		Options.online = online;
	}
	public static boolean isOnline() {
		return online;
	}
	
	@SuppressWarnings("static-access")
	public void changelocale(){
		
		if (local.getDefault().toString().equalsIgnoreCase("es_ES")){
			
			local.setDefault(new Locale("en", "US"));
		}
		else{
			local.setDefault(new Locale("es", "ES"));
		}
	}
	@SuppressWarnings("static-access")
	public void initlocale(String str){
		
		if (str.equalsIgnoreCase("en")){
			
			local.setDefault(new Locale("en", "US"));
		}
		else{
			local.setDefault(new Locale("es", "ES"));
		}
	}

}
