
import java.io.File;
import java.io.IOException;
import java.util.ResourceBundle;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiUnavailableException;

import database.DbScores;
import database.DbSongs;
import database.TableScores;
import database.TableSongs;

import file.FileScores;
import file.FileSongs;

import sdljava.SDLException;
import sdljava.ttf.SDLTTF;
import sdljava.video.SDLSurface;

public class SelectStory {

	private CFrame frameplayer;
	private CFrame framecircle;
	
	private 	CSprite spriteplayer;
	private CSprite spritecircle;
	
	private CFrame framecity;
	private CSprite spritecity;
	
	private Event event;
	private boolean end;
	
	private int selectlevelx;
	private int selectlevely;
	private int maxlevelx = 5;
	private int maxlevely = 5;
	
	private Text textArabica30;
	
	
	
	private MidiPlayer player;
	private String song1 ;
	
	private String [][] map=
	{	
		{"campanitas" ,"escala"	,"campanitas","campanitas","campanitas"				},
		{"campanitas2",	null	,"campanitas",null		  ,"campanitas"				},
		{"campanitas" ,	null	,"campanitas","campanitas","campanitas","campanitas"}
	};
	public SelectStory (){
		event = new Event();
		end = false;
		selectlevelx = 0;
		selectlevely = 0;
		song1 = "";
		this.initsprites();//initsprites();
		this.player = new MidiPlayer();
		song1 = map[selectlevelx][selectlevely];
		
		 textArabica30 = new Text();
		 textArabica30.init("fonts"+  File.separator + "arabica.ttf",30);

	}
	 public void initsprites() {
		try{
			 frameplayer= new CFrame();
			 spriteplayer = new CSprite();
			
			 framecircle = new CFrame();
			 spritecircle = new CSprite();
			 
			 framecity = new CFrame();
			 spritecity = new CSprite();
			 
			 framecity.load("sprites"+  File.separator + "city.png");	
			 spritecity.addframe(framecity);
			 
			 frameplayer.load("sprites"+  File.separator + "buttoncircle.png");		
			spriteplayer.addframe(frameplayer);
			
			framecircle.load("sprites"+  File.separator + "mapcircle.png");
			spritecircle.addframe(framecircle);

		}
		catch(Exception e){
			System.out.println("Error selectstory.initsprites "+e);
		}
	}
		
	public void draw(SDLSurface screen) {
	
		try{
			
			spritecity.draw(screen);
			
			for (int i = 0;i <=this.maxlevelx;i++){
				
				for (int j = 0;j<=this.maxlevely;j++){
					
					try{
						if (map[j][i]!= null){
							spritecircle.setx(100+100*i);
							spritecircle.sety(200+100*j);
							spritecircle.draw(screen);
						}
					}
					catch(Exception e){
						
					}
				}
			}
		
			spriteplayer.setx(100+100*selectlevelx);
			spriteplayer.sety(200+100*selectlevely);
			spriteplayer.draw(screen);
			
			this.textArabica30.drawtext(song1, screen, 300, 500);
			
	    	screen.flip(); //Pintamos la pantalla
	    	   
		  	screen.fillRect(0); //borramos la pantalla anterior
		}
		catch(Exception e){
			System.out.println("Error selectstory.draw "+e);
		}
	}
		
	public void keyboard(SDLSurface screen){
			
		int sym = 0;
		event.setEvent();
		
		try{
			if (event.isPressed()){
					
				sym = event.getSym();
				switch (sym){
				
			    	case 27 : //esc
			    		
			    		this.player.stop();
						Popup menuesc = new Popup();
						menuesc.set("Salir","¿Seguro que quieres salir?","Continuar","Salir");
						this.end = (2 ==  menuesc.go(screen));
			    		
			    		break;
			    	case 276: //izquierda
			    		try{
			    			if (map[selectlevely][selectlevelx-1] != null){
				    			song1 =map[selectlevely][selectlevelx-1];
	
			    				selectlevelx--;
			    			
				    			player.close();
				    			player.play( song1);
			    			}
			    		}
			    		catch(Exception e){
	
			    		}
			    		break;
			    	case 275: //derecha
			    		try{
			    			
				    		if (map[selectlevely][selectlevelx+1] != null){
				    			song1 =map[selectlevely][selectlevelx+1];
				    			selectlevelx++;
				    		
	
				    			player.close();
				    			player.play( song1);
				    		}
				    		
			    		}
			    		catch(Exception e){
	
			    		}
			    		break;
			    	case 274: //arriba
			    		
			    		try{
			    			if (map[selectlevely+1][selectlevelx] != null){
				    			song1 =map[selectlevely+1][selectlevelx];
			    				selectlevely++;
				    			
					    		player.close();
					    		player.play( song1);
			    			}
						}
						catch(Exception e){
				
						}
			    		break;
			    	case 273: //abajo
			    		
			    		try{
			    			if (map[selectlevely-1][selectlevelx] != null){
				    			song1 =map[selectlevely-1][selectlevelx];
	
					    		selectlevely--;
		
					    		player.close();
					    		player.play( song1);
			    			}
				    		
						}
						catch(Exception e){
				
						}
			    		break;
			    	case 13: //enter
						player.stop();
						//player.close();
			    		
			    		Play play = new Play();
			    		play.go(screen,song1);
	
			    		//retorno de play
			    		player.play( song1);
			    		
			    		break;
		    	}
			}
			this.draw(screen);
		}
		catch(Exception e){
			System.out.println("Error selectstory.keyboard "+e);
		}
	}
	
	public int go(SDLSurface screen){

		player.play( song1);
		
		this.draw(screen);
		
		this.end = false;
		
		while (!this.end){
			
			try {
				this.keyboard(screen);
				Thread.sleep(50);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		this.player.stop();
		
		return 0;
	}
	
}
